---

- name: Ubuntu 14.04 | Set gcc 4.8
  ansible.builtin.set_fact:
    gcc_v: 4.8
  when: ansible_distribution == 'Ubuntu' and ansible_distribution_version.split('.')[0] | int <= 14
- name: Ubuntu 15.04+ | Set gcc 5
  ansible.builtin.set_fact:
    gcc_v: 5
  when: ansible_distribution == 'Ubuntu' and ansible_distribution_version.split('.')[0] | int >= 15

## Note: can't do before full end of provisioning else might break other things...
- name: Debian, RedHat | Compiler restrictions
  when: ansible_os_family == 'Debian' or ansible_os_family == 'RedHat'
  block:
    - name: Restrict compiler tools to group {{ harden_restrict_compiler_group }}
      ansible.builtin.file:
        path: "{{ item }}"
        owner: root
        group: "{{ harden_restrict_compiler_group }}"
        mode: "{{ harden_restrict_compiler_umask }}"
        follow: yes
      with_items:
        # - /usr/bin/gcc-{{ gcc_v }}
        - /usr/bin/cc
        - /usr/bin/gcc
        - /usr/bin/gcc-ar
        - /usr/bin/gcc-nm
        - /usr/bin/gcc-ranlib
        - /usr/bin/make
        - /usr/bin/g++
        - /usr/bin/c++
      ## Note: ignore errors as compiler tools may not be installed...
      failed_when: false

- name: Alpine | Compiler restrictions
  when: ansible_os_family == 'Alpine'
  block:
    ## https://github.com/ansible/ansible/issues/13652
    - name: Alpine | Restrict compiler tools to group {{ harden_restrict_compiler_group }}
      ansible.builtin.file:
        path: "{{ item }}"
        owner: root
        group: "{{ harden_restrict_compiler_group }}"
        mode: "{{ harden_restrict_compiler_umask }}"
        state: file
      with_items:
        - /usr/bin/gcc
        - /usr/bin/gcc-ar
        - /usr/bin/gcc-nm
        - /usr/bin/gcc-ranlib
        - /usr/bin/make
        - /usr/bin/g++
      failed_when: false
